{$R-,S-,I-,D-,F+,V-,B-,N-,L+}
Unit ConfigS;

Interface
Uses Crt, Dos, Types, BCShare;

Procedure ReadConfig;
Procedure WriteConfig;

Type
  ConfigRec=
    Record
      {Communicatioin Info}
      Unused                  : Word;
      {Directory Info}
      BBSDir,
      TextDir,
      BoardDir,
      FilesDir,
      DataDir,
      MenuDir,
      WorkDir,
      TFileDir,
      FileMailDir,
      DoorDir,
      LogDir                  : LStr;
      {Board Info}
      SysopName,
      BoardName               : MStr;
      {File Info}
      KForEachPoint           : Word;
      AutoValidFiles,
      ExternalFileAreaListing,
      FRepeatMethod,
      CommissionFP            : Boolean;
      PercentCTU              : Word;
      DSZLogName              : LStr;
      PointsBackPC            : Word;
      {ACS Flags}
      PostAnon,
      SysopACS,
      MSysopACS,
      FSysopACS               : MStr;
      {EMail Info}
      AllowFileMail           : Boolean;
      DaysToKeepFM            : Word;
      {MultiNode Information}
      MultiNodeOp             : Boolean;
      NodeNumber              : Word;
      {Message Area}
      ExternalBaseListing,
      MRepeatMethod           : Boolean;
      {Color Config}
      DefRegColor,
      DefStatColor,
      DefPromptColor,
      DefInputColor,
      DefInverseColor,
      DefBoxColor             : Byte;
      {New User Configuration}
      DefaultFlags            : MStr;
      DefLevel,
      DefFLevel,
      DefFilePoints,
      DefUDR,
      DefUDKR,
      DnKPerDay,
      DefPCR,
      DefUpCPS,
      DefDnCPS,
      DefTimeLimit            : Word;
      NumMinsBeforeTimeOut    : Word;
      HiddenInputChar         : Char;
      {Infoforms}
      InfoformData            :
        Array[1..5] Of Record
          InfoName          : MStr;
          MandatoryInfoform : Boolean;
        End;
      Unused2                 : Boolean;
      SysPass,
      System1Pass,
      NewUserPass             : MStr;
      DescForm                : Array[1..8] Of String[45];
      NumExt                  : Word;
      PercentTimeBack         : Word;
      Ports                   : Array[1..NumNodes] Of Word;
      InitStr                 : Array[1..NumNodes] Of LStr;
      HangUpStr               : Array[1..NumNodes] Of LStr;
      OffHookStr              : Array[1..NumNodes] Of LStr;
      SendCarrierStr          : Array[1..NumNodes] Of LStr;
      ReceiveCarrierStr       : Array[1..NumNodes] Of LStr;
      DefBaud                 : Array[1..NumNodes] Of Word;
      MinBaud                 : Array[1..NumNodes] Of Word;
      LockOutPass             : MStr;
      ManualAnswer            : Array[1..NumNodes] Of Boolean;
      DaysToSaveLog           : Word;
      CanDoExec               : MStr;
      ScrollLines             : Word;
      TotPTimes               : Word;
      PostMand                : Mstr;
      QWKName                 : Sstr;
      UseBios,
      UseMaintain,
      KickOffNotV             : Boolean;
      SMenu                   : SStr;
      SysopAutologin,
      SLineOn,
      UseNuv                  : Boolean;
      VotesToValid,
      VotesToDel              : Word;
      DefUserNote             : MStr;
      ComSpecifying           : MStr;
      MinKForUpload           : Word;
      ValCode,
      DailyFlagChange,
      CallFlagChange          : MStr;
      QWKCheckTL              : Boolean;
      UseCPS                  : Boolean;
      SwapDir                 : LStr;
      UserTransferLine        : Word;
      LibraryDAAnsi,
      SearchAll               : Boolean;
      FileMailACS,
      TopTenACS,
      RRACS                   : MStr;
      UseULChecker            : Boolean;
      DayConstraint           : Word;
      ScanCom                 : LStr;
      BBSAd,
      CommentFN               : SStr;
      BadDir                  : LStr;
      FilesList               : Sstr;
      CheckSpace,
      ClearLFOpts             : Boolean;
      TopTenC                 : Char;
      OptsPerLine             : Word;
      ReadMenuForGeneric      : Boolean;
      DaysToAddFNuv           : Word;
      UseFileCatalog,
      FileCatalogLookup,
      ConfSearch,
      UseQuoteHeader,
      UseGreaterThanSign      : Boolean;
      NumLPNode               : Word;
      UseRip                  : Boolean;
      AskAvailabilityACS      : MStr;
      UsePrelogon,
      UseWelcome,
      SpecialLogin            : Boolean;
      Special1ACS,                      {- Commands (Control)}
      Special2ACS,                      {& Commands (Multinode)}
      Special3ACS,                      {{ Commands (Matrix)}
      Special4ACS,                      {. Commands (Doors)}
      Special5ACS,                      {* Commands (Sysop)}
      Special6ACS,                      {^ Commands (NUV)}
      SpecialCACS,                      {C Commands (Conference Editor)}
      SpecialDACS,                      {D Commands (Data Area Editor)}
      SpecialEACS,                      {E Commands (Email)}
      SpecialFACS,                      {F Commands (File)}
      SpecialJACS,                      {J Commands (Jump Conference)}
      SpecialMACS,                      {M Commands (Message Base)}
      SpecialNACS,                      {N Commands (Singular Read)}
      SpecialQACS,                      {Q Commands (QWK Menu)}
      SpecialSACS,                      {S Commands (Message Base Sponsor)}
      SpecialTACS,                      {T Commands (File Sponsor)}
      SpecialVACS             : MStr;   {V Commands (Voting)}
      AllowUseofGandIMesComs,
      HangUpAfterCalls,
      ExternalMesHelp,
      ExternalFileHelp,
      YNCharsInApp,
      MakeDoorForMaintain,
      SwapToEMS,
      SwapToXMS,
      OpenCloseFDF            : Boolean;
      Lockat1152              : Array[1..NumNodes] Of Boolean;
      WaitUntilFlushed        : Array[1..NumNodes] Of Boolean;
      GiveUpTimeSlices        : Boolean;
      MultiNodeDir            : LStr;
      InformUsers             : Boolean;
      ExtractPercentage       : Word;
      DoLogChat,
      RenameFiles,
      RunCopy,
      MultinodeFriendly,
      DontDoDevCheck          : Boolean;
      BaseAddresses           : Array[1..NumNodes] Of String[4];
      IrqNums                 : Array[1..NumNodes] Of Word;
      NewUserVotingInfoform   : Array[1..5] Of Boolean;
      HiddenFilesACS          : MStr;
      ChangeDirACS            : MStr;
      IncPromptsDir           : LStr;
      InformLogoff            : Boolean;
      WFCOption               : Array[1..9] Of WFCO;
      UseWFCOpts,
      AutoValNewUsers         : Boolean;
    End;

Var
  ConfigI:ConfigRec;

Implementation

Procedure ReadConfig;
Var
  CFile  : File Of ConfigRec;
  Ignore : Integer;
  BBSD   : String;

Begin
  BBSD:=GetEnv('BBSDIR');
  Ignore:=IOResult;
  Assign(CFile,BBSD+'CONFIG.BBS');
  SetFileMode(ReadDenyNone);
  Ignore:=IoResult;
  Repeat
    Reset(CFile);
    Ignore:=IoResult;
    If Ignore=5 Then Delay(300);
  Until Ignore<>5;
  SetFileMode(NormalMode);
  If Ignore<>0 Then
  Begin
    WriteLn('CONFIG.BBS is not found.  Run Oblivion/2 to create one');
    Halt(255);
  End;
  Read(CFile,ConfigI);
  Close(CFile);
End;

Procedure WriteConfig;
Var
  CFile  : File Of ConfigRec;
  Ignore : Integer;
  BBSD   : String;

Begin
  BBSD:=GetEnv('BBSDIR');
  Ignore:=IOResult;
  Assign(CFile,BBSD+'CONFIG.BBS');
  SetFileMode(NormalMode);
  Ignore:=IoResult;
  Repeat
    Rewrite(CFile);
    Ignore:=IoResult;
    If Ignore=5 Then Delay(300);
  Until Ignore<>5;
  SetFileMode(NormalMode);
  Write(CFile,ConfigI);
  Close(CFile);
End;

End.